/****************************************************************************
Module name: MeterDlg.C
Programmer : Jeffrey M. Richter.
*****************************************************************************/

#include "..\nowindws.h"
#define  OEMRESOURCE
#undef   NOCOLOR
#undef   NOCTLMGR
#undef   NOGDI
#undef   NOKERNEL
#undef   NOLSTRING
#undef   NOMEMMGR
#undef   NORASTEROPS
#undef   NOUSER
#undef   NOVIRTUALKEYCODES
#undef   NOWINMESSAGES
#undef   NOWINOFFSETS
#undef   NOWINSTYLES
#include <windows.h>
#include <custcntl.h>

#include "cntl-de.h"

#include "meter.h"
#include "dialog.h"

extern HANDLE _hInstance;
extern char _szControlName[];

BOOL FAR PASCAL MeterDlgFn (HWND hDlg, WORD wMessage, WORD wParam, LONG lParam);


GLOBALHANDLE FAR PASCAL MeterInfo (void) {
   GLOBALHANDLE hCtlInfo = NULL;

   hCtlInfo = ControlInfo(0x0100, _szControlName, _szControlName);
   if (hCtlInfo == NULL) return(hCtlInfo);
   AddControlType(hCtlInfo, 0, 40, 12, WS_BORDER | WS_CHILD, _szControlName);
   return(hCtlInfo);

}

BOOL FAR PASCAL MeterStyle (HWND hWnd, GLOBALHANDLE hCtlStyle,
                        LPFNSTRTOID lpfnStrToId, LPFNIDTOSTR lpfnIdToStr) {
   return(ShowStyleDlg(_hInstance, MAKEINTRESOURCE(DLG_STYLEDLG),
      hWnd, (FARPROC) MeterDlgFn, 0, hCtlStyle, lpfnStrToId, lpfnIdToStr));
}

BOOL FAR PASCAL MeterDlgFn (HWND hDlg, WORD wMsg, WORD wParam, LONG lParam) {
   BOOL fResult = TRUE;
   char szId[20];
   DWORD dwResult;

   switch (wMsg) {
      case WM_INITDIALOG:
         GetIdString(hDlg, szId, sizeof(szId));
         SetDlgItemText(hDlg, ID_VALUE, szId);
         break;

      case WM_COMMAND:
         switch (wParam) {
            case IDOK:
               GetDlgItemText(hDlg, ID_VALUE, szId, sizeof(szId));
               dwResult = SetIdValue(hDlg, szId);
               if (LOWORD(dwResult) == 0) break;
               // Fall through to IDCANCEL case

            case IDCANCEL:
               EndDialog(hDlg, wParam);
               break;

            case ID_VALUE:
               if (HIWORD(lParam) == EN_CHANGE)
                  EnableWindow(GetDlgItem(hDlg, IDOK),
                     SendMessage(LOWORD(lParam), WM_GETTEXTLENGTH, 0, 0L)
                     ? TRUE : FALSE);
               break;

            default: fResult = FALSE; break;
         }
         break;

      default: fResult = FALSE; break;
   }
   return(fResult);
}

WORD FAR PASCAL MeterFlags (DWORD dwFlags, LPSTR szString, WORD wMaxString) {
   WORD x;
   *szString = 0;
   x = lstrlen(szString);
   if (x > 0) { x -= sizeof(" | ") - 1; *(szString + x) = 0; }
   return(x);
}

